package neuroet;

import java.util.Comparator;
/**
 * <p>Title: Neural Net Classes</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: University of Washington</p>
 * @author Erik Tribou
 * @version 1.0
 */

public final class DoubleHolder extends Object
{
  private final double x;
  private final double y;

  DoubleHolder(double f, double s)
  {
   x = f;
   y = s;
  }

  public double GetFirst()
  {
    return x;
  }

  public double GetSecond()
  {
    return y;
  }

  public String toString()
  {
     return x + "\t" + y;
  }

  public static final Comparator firstAscending = new Comparator()
  {
    public int compare(Object o1, Object o2)
    {
      double x1 = ((DoubleHolder)o1).GetFirst();
      double x2 = ((DoubleHolder)o2).GetFirst();

      if (x1 > x2)
         return 1;
      if (x1 < x2)
         return -1;
      return 0;

    }
  };

  public static final Comparator firstDescending = new Comparator()
  {
    public int compare(Object o1, Object o2)
    {
      double x1 = ((DoubleHolder)o1).GetFirst();
      double x2 = ((DoubleHolder)o2).GetFirst();

      if (x1 > x2)
         return -1;
      if (x1 < x2)
         return 1;
      return 0;

    }
  };

  public static final Comparator secondAscending = new Comparator()
  {
    public int compare(Object o1, Object o2)
    {
      double x1 = ((DoubleHolder)o1).GetSecond();
      double x2 = ((DoubleHolder)o2).GetSecond();

      if (x1 > x2)
         return 1;
      if (x1 < x2)
         return -1;
      return 0;

    }
  };

  public static final Comparator secondDescending = new Comparator()
  {
    public int compare(Object o1, Object o2)
    {
      double x1 = ((DoubleHolder)o1).GetSecond();
      double x2 = ((DoubleHolder)o2).GetSecond();

      if (x1 > x2)
         return -1;
      if (x1 < x2)
         return 1;
      return 0;

    }
  };





}


