package neuroet;

import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class FileChoosingPanel extends JPanel implements ActionListener
{
    private File theFile;
    private final JTextField display;
    private final FileDialog myChooser; //we precreate our file chooser for faster performance

    private final JButton myBu;
    private final JLabel lab;

    public void SetPrefLabelWidth(int wid)
    {
      Dimension d = lab.getPreferredSize();
      d.width = Math.max(wid, d.width);

      lab.setPreferredSize(d);
    }

    public int GetPrefLabelWidth ()
    {
      return lab.getPreferredSize().width;
    }

    public static void FixLabelWidths(FileChoosingPanel one, FileChoosingPanel two)
    {
      int dOne = one.GetPrefLabelWidth();
      int dTwo = two.GetPrefLabelWidth();

      if (dOne > dTwo)
      {
        two.SetPrefLabelWidth(dOne);
      }
      else if (dTwo > dOne)
      {
        one.SetPrefLabelWidth(dTwo);
      }

    }

    FileChoosingPanel(Frame parent, String dialogMessage,String title)
    {
    super(new FlowLayout(FlowLayout.LEFT));


    lab = new JLabel(title);



    display = new JTextField(15);


    myBu = new JButton ("Choose");


    add(lab);
    add (display);

    add (myBu);

    display.setEditable(false);
    myBu.addActionListener (this);


    myChooser = new FileDialog(parent, dialogMessage,FileDialog.LOAD);


    Utilities.FixMaximumSize(this);

    }

    FileChoosingPanel (Frame parent, String dm, String t, FilenameFilter f)
    {
    	this(parent, dm, t);
    	myChooser.setFilenameFilter(f);
    }

    public File getFile()
    {
        return theFile;
    }

    void setFile(File toSet)
    {
        theFile = toSet;
        display.setText(toSet.getName());
    }

    int GetButtonWidth()
    {
    	return myBu.getPreferredSize().width;
    }

    public void actionPerformed (ActionEvent q)
    {
        //JFileChooser myChooser = new JFileChooser();

        myChooser.show();

        if (myChooser.getFile() != null)
        {
            display.setText(myChooser.getFile());
            try
            {
            theFile = new File(myChooser.getDirectory(),myChooser.getFile());
            }catch (Exception h){throw new Error("Couldn't convert file" + h);}
        }
    }
}
