//Input Layer just takes a matrix and will cycle through the rows as GetOutputs is called

package neuroet;
import java.io.PrintWriter;

public final class InputLayer extends Layer
{
	private transient double[][] data;
	private transient int current;
        private int nOutPuts;
        private final static long serialVersionUID= 54135320231L;

	InputLayer(double[][] d)
	{
		previousLayer = null;
		data = d;
		current = 0;

                nOutPuts = data[0].length;
		if (d.length < 1)
                  throw new IllegalStateException("Can't create layer with 0 inputs");


	}

	public int NumOutputs()
	{
		return nOutPuts;
	}

	public int NumIterations()
	{
              if(data == null)
                return 0;
              return data.length;
	}

	public double[] GetOutputs()
	{
		if (current == data.length)
			current = 0;
		return data[current++];
	}


	public Layer copy()
	{
		return new InputLayer(data);
	}

	public void AdjustWeightsAndBiases(double[] error)  //does nothing by default
	{

	}

	public double[] CalculateGradient(int requested, double[] sensitivity)
	{
		return new double[requested];
	}

	public int NumParams()
	{
		return 0;
	}

	public void ModifyNetwork(int current, double[] vals)//do nothing except check that we have no more args
	{
		if (vals.length != current)
			throw new IllegalArgumentException("Still have vals at Input Layer");

	}

        public void PrintNetworkWeights(PrintWriter pw)
        {
          //do nothing
        }

        public void PrintNetworkBiases(PrintWriter pw)
        {
         //do nothing
        }

}