package neuroet;

/**
 * <p>Title: Neural Net Classes</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: University of Washington</p>
 * @author Erik Tribou
 * @version 1.0
 */

public class IntSetIterator
{

  private final int size;
  private final int min;
  private final int max;
  private int[] ptrs;
  private boolean more;

  public IntSetIterator(int mn, int mx, int sz)
  {
    if (mn > mx)
      throw new IllegalArgumentException("Min must be less than max");

    size = sz;
    max = mx;
    min = mn;
    ptrs = new int[sz];//all initialized to 0

    for (int x = 1; x < ptrs.length; x++)
    {
      ptrs[x] = x;
    }

    more = true;
  }

  public int GetNumIterations()
  {
    return Utilities.Choose(max - min, size);
  }

  public int[] GetNext()
  {
    int[] tr = new int[size];




    for (int x = 0; x < tr.length; x++)
    {
      tr[x] = ptrs[x] + min;
    }

    int currPtr = ptrs.length - 1;
    int lim = max - min;

    for (;;)
    {
      if (currPtr < 0)
      {
        more = false;
        return tr;
      }

      if (ptrs[currPtr]== lim)//if pointing to the last
      {
        currPtr--;
        lim--;
      }
      else
      {
        break;
      }

    }

    ptrs[currPtr]++;
    currPtr++;

    for (;currPtr < ptrs.length;currPtr++)
    {
      ptrs[currPtr] = ptrs[currPtr - 1] + 1;//reset
    }

    return tr;
  }

  public boolean hasMore()
  {
    return more;
  }
}