package neuroet;

import java.util.Comparator;

/**
 * <p>Title: Neural Net Classes</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: University of Washington</p>
 * @author Erik Tribou
 * @version 1.0
 */

public final class IntegerDoubleHolder
{

  private final int i;
  private final double d;

  IntegerDoubleHolder(int n, double o)
  {
    i = n;
    d = o;
  }

  public int GetInt()
  {
    return i;
  }

  public double GetDouble()
  {
    return d;
  }

  public String toString()
  {
    return i + "\t" + d;
  }

  public static final Comparator intAscending = new Comparator()
  {
    public int compare(Object o1, Object o2)
    {
      int x1 = ((IntegerDoubleHolder)o1).GetInt();
      int x2 = ((IntegerDoubleHolder)o2).GetInt();

      return x1 - x2;

    }
  };

  public static final Comparator intDescending = new Comparator()
  {
    public int compare(Object o1, Object o2)
    {
      int x1 = ((IntegerDoubleHolder)o1).GetInt();
      int x2 = ((IntegerDoubleHolder)o2).GetInt();

      return x2 - x1;

    }
  };

  public static final Comparator doubleAscending = new Comparator()
  {
    public int compare(Object o1, Object o2)
    {
      double x1 = ((IntegerDoubleHolder)o1).GetDouble();
      double x2 = ((IntegerDoubleHolder)o2).GetDouble();

      if (x1 > x2)
         return 1;
      if (x1 < x2)
         return -1;
      return 0;

    }
  };

  public static final Comparator doubleDescending = new Comparator()
  {
    public int compare(Object o1, Object o2)
    {
      double x1 = ((IntegerDoubleHolder)o1).GetDouble();
      double x2 = ((IntegerDoubleHolder)o2).GetDouble();

      if (x1 > x2)
         return -1;
      if (x1 < x2)
         return 1;
      return 0;

    }
  };

}