/*
	Application1.java

	Author:			Erik Tribou
	Description:
*/

package neuroet;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;


public class PrefPanel extends JDialog
{
	private static final String[] afs = {"Hyperbolic Tangent", "Log-Sigmoid", "Pure Linear", "Exponential (e^x)"};
	private static final String[] scalingMeth = {"No Scaling","Standard Linear [-1 , 1]", "Standard Linear [0 , 1]","Standardized  \u03bc=0  \u03c3=1"};

	private static final int defLafs = 0; // 0 standard // 1 log sig //2 standard // 3 exponent
	private static final int defRafs = 2;

	private static final int defInpScal = 3; // now it is set to standardized //1
	private static final int defOutScal = 3;  // now it is set to standardized//3

	private final JComboBox lScaling;
	private final JComboBox lAFs;
	private final JCheckBox hBias;
	private final JSlider mySlider;
	private final JComboBox rScaling;
	private final JComboBox rAFs;
	private final JCheckBox oBias;
        private final ProportionPanel testPanel;
        private final ProportionPanel validationPanel;

        private PrefModel backup;
        private boolean restoreBackup;


	public PrefPanel(Frame f, String title)
	{
			super(f, title, true);

			lScaling = new JComboBox(scalingMeth);

			lScaling.setSelectedIndex(defInpScal);

			lAFs = new JComboBox(afs);

			lAFs.setSelectedIndex(defLafs);

			hBias = new JCheckBox("Include Bias Term", true);
			mySlider = new JSlider(1, 100, 2);
			rScaling = new JComboBox(scalingMeth);

			rScaling.setSelectedIndex(defOutScal);

			rAFs = new JComboBox(afs);


			rAFs.setSelectedIndex(defRafs);

			oBias = new JCheckBox("Include Bias Term",true);

			JPanel ourPane = (JPanel)getContentPane();
			ourPane.setBorder(new EmptyBorder(5,5,25,5));

			ourPane.setLayout(new BoxLayout(ourPane,BoxLayout.Y_AXIS));

			JPanel lPan = new JPanel();//hidden layer settings
			JPanel rPan = new JPanel();//output layer settings



			//ourPane.add(new JSeparator(SwingConstants.HORIZONTAL));
			//ourPane.add(Box.createVerticalStrut(5));



			lPan.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"Hidden Layer Settings"));
			rPan.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"Output Layer Settings"));

			lPan.setLayout(new BoxLayout(lPan, BoxLayout.Y_AXIS));
			rPan.setLayout(new BoxLayout(rPan, BoxLayout.Y_AXIS));

			JPanel lOne = new JPanel (new FlowLayout(FlowLayout.LEFT));
			JPanel lTwo = new JPanel (new FlowLayout(FlowLayout.LEFT));
			JPanel lThree = new JPanel (new FlowLayout(FlowLayout.LEFT));
			JPanel lFour = new JPanel (new FlowLayout(FlowLayout.LEFT));
			JPanel lFive = new JPanel(new BorderLayout());




			lOne.add(new JLabel("Input Scaling Method: "));
			lOne.add(lScaling);

			lTwo.add(new JLabel("Transfer Function:  "));
			lTwo.add(lAFs);



			lThree.add(hBias);





			final JLabel nodes = new JLabel();

			mySlider.addChangeListener(new SliderListener(mySlider, nodes));

			lFour.add (new JLabel("Number of Hidden Neurons: "));
			lFour.add (nodes);

			mySlider.setMajorTickSpacing(10);
			mySlider.setPaintTicks(true);
			mySlider.setPaintLabels(true);




			lFive.add(mySlider);


			JPanel rOne = new JPanel (new FlowLayout(FlowLayout.LEFT));
			JPanel rTwo = new JPanel (new FlowLayout(FlowLayout.LEFT));
			JPanel rThree = new JPanel (new FlowLayout(FlowLayout.LEFT));
			JPanel rFour = new JPanel (new FlowLayout(FlowLayout.RIGHT));




			rOne.add(new JLabel("Target Scaling Method: "));
			rOne.add(rScaling);

			rTwo.add(new JLabel("Transfer Function:   "));
			rTwo.add(rAFs);



			rThree.add(oBias);
			JButton cancel = new JButton("Cancel");
			JButton ok = new JButton("   OK   ");


			cancel.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					hide();
				}
			});


                        this.addWindowListener(new WindowAdapter()//depends on modality for this window
                        {
                          public void windowClosed(WindowEvent e)
                          {
                            hide();
                          }



                        });

			ok.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
                                        restoreBackup = false;
					hide();
				}
			});

			rFour.add(cancel);
			rFour.add(ok);

			lPan.add(lOne);
			lPan.add(lTwo);
			lPan.add(lThree);
			lPan.add(lFour);
			lPan.add(lFive);

			rPan.add(rOne);
			rPan.add(rTwo);
			rPan.add(rThree);


                        testPanel = new ProportionPanel(0, 25, "Proportion in Test: ");
                        validationPanel = new ProportionPanel(0, 25, "Proportion in Validation: ");

                        JPanel proportions = new JPanel();
                        proportions.setLayout(new BoxLayout(proportions, BoxLayout.Y_AXIS));
                        proportions.add(testPanel);
                        proportions.add(validationPanel);



                        proportions.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"Data Set Proportions (Applies only to training)"));


                        ourPane.add(lPan);//hidden layer
			ourPane.add(Box.createVerticalStrut(10));
			ourPane.add(rPan);//output layer
                        ourPane.add(Box.createVerticalStrut(10));
                        ourPane.add(proportions);

			ourPane.add(rFour);//the buttons

			ourPane.getRootPane().setDefaultButton(ok);

			ourPane.setBackground(lPan.getBackground());



			setResizable(false);
                        pack();
                        //System.out.println(this.getPreferredSize());
			//show();
	}

        //ensures show and hide are called to display the window
        public void setVisible(boolean b)
        {
          if (b)
            show();
          else
            hide();
        }

        public void show()
        {
          if (!this.isVisible())
          {
            restoreBackup = true;
            backup = new PrefModel();
          }

          super.show();

        }

        public void hide()
        {

          if (this.isVisible())
          {
            if (restoreBackup)
              backup.Restore();

            backup = null; //for gc
          }

          super.hide();

        }

        class PrefModel
        {
          private final int scaleMeth;
          private final int hiddAct;
          private final boolean hiddBias;
          private final int numHidd;

          private final int outScale;
          private final int outAct;
          private final boolean outBias;

          private final int testProp;
          private final int validProp;



          PrefModel()
          {
            scaleMeth = lScaling.getSelectedIndex();
            hiddAct = lAFs.getSelectedIndex();

            hiddBias = hBias.isSelected();
            numHidd = mySlider.getValue();

            outScale = rScaling.getSelectedIndex();
            outAct = rAFs.getSelectedIndex();
            outBias = oBias.isSelected();

            testProp = testPanel.GetRealValue();
            validProp = validationPanel.GetRealValue();

          }

          public void Restore()
          {
            lScaling.setSelectedIndex(scaleMeth);
            lAFs.setSelectedIndex(hiddAct);

            hBias.setSelected(hiddBias);
            mySlider.setValue(numHidd);

            rScaling.setSelectedIndex(outScale);
            rAFs.setSelectedIndex(outAct);

            oBias.setSelected(outBias);
            testPanel.SetProportion(testProp);
            validationPanel.SetProportion(validProp);
          }

        }
        public double GetTestProportion()
        {
         return testPanel.GetProportion();
        }

        public double GetValidationProportion()
        {
          return validationPanel.GetProportion();
        }



	//expects data in ROWS, not columns
	public Scaler[] GetInputScalers(double[][] inps)
	{
		Scaler[] toReturn = new Scaler[inps.length];


		for (int x = 0; x < toReturn.length; x++)
		{
			toReturn[x] = ResolveScaler(inps[x], (String)lScaling.getSelectedItem());
		}

		return toReturn;
	}

	/*public Neuron[] GetHiddenNeurons(int inpLen)
	{
		Neuron[] toReturn = new Neuron[mySlider.getValue()];

		if (hBias.isSelected())
		{
			for(int x = 0; x < toReturn.length; x++)
			{
				toReturn[x] = new Neuron(inpLen, GetHiddenActivationFunction());
			}
		}
		else
		{
			for (int x = 0; x < toReturn.length; x++)
			{
				toReturn[x] = new NoBiasNeuron(inpLen, GetHiddenActivationFunction());
			}

		}
		return toReturn;
	}*/


	private ActivationFunction GetHiddenActivationFunction()
	{
		return ResolveActivationFunction((String)lAFs.getSelectedItem());
	}


        public NeuronMaker GenerateNeuronMaker()
        {
          //final int hidden = mySlider.getValue();
          final boolean bias = oBias.isSelected();
          final ActivationFunction oaf = GetOutputActivationFunction();
          final boolean hiddenBias = hBias.isSelected();
          final ActivationFunction hiddenActivationFunction = GetHiddenActivationFunction();

          return new NeuronMaker()
          {
            private int hidden = mySlider.getValue();

            public Neuron GetOutputNeuron(int numHidden)
            {
              if (bias)
              {
                return new Neuron(numHidden, oaf);
              }
              //else !bias
              return new NoBiasNeuron(numHidden, oaf);

            }

            public void SetNumberHidden(int hid)
            {
              hidden = hid;

            }

            public Neuron[] GetHiddenNeurons(int numInputs)
            {
              Neuron[] toReturn = new Neuron[hidden];

              if (hiddenBias)
              {
                      for(int x = 0; x < toReturn.length; x++)
                      {
                              toReturn[x] = new Neuron(numInputs, hiddenActivationFunction);
                      }
              }
              else
              {
                      for (int x = 0; x < toReturn.length; x++)
                      {
                              toReturn[x] = new NoBiasNeuron(numInputs, hiddenActivationFunction);
                      }

              }


              return toReturn;
            }

          };

        }

        /*
	public Neuron GetOutputNeuron()
	{
		int prev = mySlider.getValue();

		if (oBias.isSelected())
		{
			return new Neuron(prev,GetOutputActivationFunction());
		}
		//else
		return new NoBiasNeuron(prev,GetOutputActivationFunction());
	}*/

	public Scaler GetOutputScaler(double[] outps)
	{
		return ResolveScaler(outps, (String)rScaling.getSelectedItem());
	}

	private ActivationFunction GetOutputActivationFunction()
	{
		return ResolveActivationFunction((String)rAFs.getSelectedItem());
	}

	private static Scaler ResolveScaler(double[] data,String ss)
	{



		if(ss == scalingMeth[0])
		{
			return Scaler.GetDoNothingScaler();
		}

		if(ss == scalingMeth[1])
		{
			return Scaler.GetLinearScaler(data,-1.0, 1.0);
		}

		if(ss == scalingMeth[2])
		{
			return Scaler.GetLinearScaler(data, 0.0, 1.0);
		}

		if(ss == scalingMeth[3])
		{
			return Scaler.GetStandardNormalScaler(data);
		}


		throw new IllegalArgumentException("Bad Scaler Name passed in: " + ss);


	}

	private static ActivationFunction ResolveActivationFunction(String af)
	{
		if(af == afs[0])
		{
			//System.out.println("Gave HTS");
			return ActivationFunction.HyperbolicTangentSigmoid;
		}

		if (af == afs[1])
		{
			//System.out.println("Gave LS");
			return ActivationFunction.LogSig;
		}

		if (af == afs[2])
		{
			//System.out.println("Gave PL");
			return ActivationFunction.PureLinear;
		}

		if (af == afs[3])
		{
			//System.out.println("Gave Exponential");
			return ActivationFunction.Exponential;
		}


		throw new IllegalArgumentException(af + " is not a valid activation function");

	}


}

final class ProportionPanel extends JPanel
{
  private final JSlider sl;
  ProportionPanel(int initial, int maxProp, String lab)
  {
    super();


    setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
    JPanel top = new JPanel(new FlowLayout(FlowLayout.LEFT));

    JLabel h = new JLabel("0.0");

    top.add(new JLabel(lab));
    top.add(h);
    JPanel bottom = new JPanel(new BorderLayout());

    sl = new ProportionSlider(0, maxProp, initial, h);
    bottom.add(sl);
    add(top);
    add(bottom);

  }

  public int GetRealValue()
  {
    return sl.getValue();
  }

  public void SetProportion(int prop)
  {
    sl.setValue(prop);
  }

  public double GetProportion()
  {
   return sl.getValue() / 100.0;
  }

}

final class ProportionSlider extends JSlider
{
  static final private java.text.NumberFormat nf = java.text.NumberFormat.getPercentInstance();




  ProportionSlider(int min, int max, int value, final JLabel lab)
  {
    super(min, max, value);



    if (max > 100 || min < 0)
      throw new IllegalArgumentException("Bad Min Or Max: " + min + "\t" + max);

    addChangeListener(new ChangeListener()
    {

          public void stateChanged(ChangeEvent e) {
          lab.setText(nf.format(getValue() / 100.0));// will automatically repaint

        }

    });


    setMajorTickSpacing(5);
    setPaintTicks(true);
    setPaintLabels(true);
    fireStateChanged();
  }


}


final class SliderListener implements ChangeListener {

	private final JLabel associatedLabel;


	public SliderListener (JSlider theSource, JLabel theLabel)

	{

		theLabel.setText(Integer.toString(theSource.getValue()));

		associatedLabel = theLabel;

	}



    public void stateChanged(ChangeEvent e) {

        JSlider source = (JSlider)e.getSource();

		associatedLabel.setText(Integer.toString(source.getValue()));// will automatically repaint

        }



}


